﻿<?

/*

На основе
http://infostart.ru/community/groups/622/

ALTER TABLE `ps_category_group` DROP INDEX `category_group_index` , ADD UNIQUE `category_group_index` ( `id_category` , `id_group` );
ALTER TABLE `ps_category_product` DROP INDEX `category_product_index` , ADD UNIQUE `category_product_index` ( `id_category` , `id_product` );
ALTER TABLE `ps_category` ADD `xml` VARCHAR( 36 ) NOT NULL;
ALTER TABLE `ps_product` ADD `xml` VARCHAR( 36 ) NOT NULL;

*/

define('FIX_ZIP'		,	'yes'); // true - использовать zip сжатие при получении файлов
define('FIX_ZIPSIZE'	,	2048000); // размер арива zip в байтах

ini_set('display_errors', '1');error_reporting(E_ALL);

// Инициализация
include(dirname(__FILE__).'/../../config/config.inc.php');
require_once(dirname(__FILE__).'/../../init.php');
require_once(dirname(__FILE__).'/../../images.inc.php');

// Логи
require_once 'KLogger.php';
$log = new KLogger ("log.txt" , KLogger::DEBUG );
$log->LogInfo($_SERVER['QUERY_STRING'] );

define('_PRICE_ID_'	,	Configuration::get('_PRICE_ID_'));

//  категории товара
$catar			=	array();


//========================================Загрузка фалов========================================
function loadfile(){
global $log;
	$image_data =	"";
	//Считываем файл в строку


	$filename_to_save   = _PS_PROD_PIC_DIR_ .Tools::getValue('filename');

$log->LogInfo('Загрузка: '.$filename_to_save);

	$image_data = file_get_contents("php://input");

	if(isset($image_data))	{
		if (file_exists($filename_to_save)) unlink($filename_to_save);

			$png_file = fopen($filename_to_save, "wb") or die("File not opened");
			if($png_file)	{
				set_file_buffer($png_file, 20);
				fwrite($png_file, $image_data);
				fclose($png_file);


				if (substr(Tools::getValue('filename'),-3)=='zip') {
					# распаковываем архив
					unzip(Tools::getValue('filename'),	_PS_PROD_PIC_DIR_);
					# удаляем полученный архив
					unlink($filename_to_save);
				}

				return "success";
			}
	}
	return "error POST";
}

//========================================Распаковка========================================

function unzip($file,$folder=''){
global $log;
$log->LogInfo('Распаковка: '.$file);
	$zip = zip_open($folder.$file);
	$files = 0;
	$folders = 0;

	if ($zip) {
		while ($zip_entry = zip_read($zip)) {


			$name = $folder . zip_entry_name($zip_entry);

			$path_parts = pathinfo($name);
			# Создем отсутствующие директории
			if(!is_dir($path_parts['dirname']))
			{
				mkdir($path_parts['dirname'], 0755, true);
			}


			if (zip_entry_open($zip, $zip_entry, "r")) {
				$buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));

				$file = fopen($name, "wb");
				if ($file) {
					fwrite($file, $buf);
					fclose($file);
					$files++;
				} else {

				}
				zip_entry_close($zip_entry);
			}
		}
		zip_close($zip);
	} else {

	}

}

//========================================Очистка категорий и продуктов========================================
function ClearBase(){
global $log;
$log->LogInfo('Очистка базы');
				Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'category` WHERE id_category != 1');
				Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'category_lang` WHERE id_category != 1');
				Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'category_group` WHERE id_category != 1');
				Db::getInstance()->Execute('ALTER TABLE `'._DB_PREFIX_.'category` AUTO_INCREMENT = 2 ');
				foreach (scandir(_PS_CAT_IMG_DIR_) AS $d)
					if (preg_match('/^[0-9]+\-(.*)\.jpg$/', $d) OR preg_match('/^([[:lower:]]{2})\-default\-(.*)\.jpg$/', $d))
						unlink(_PS_CAT_IMG_DIR_.$d);

				Db::getInstance()->Execute('TRUNCATE TABLE `'._DB_PREFIX_.'product');
				Db::getInstance()->Execute('TRUNCATE TABLE `'._DB_PREFIX_.'product_lang');
				Db::getInstance()->Execute('TRUNCATE TABLE `'._DB_PREFIX_.'category_product');
				Db::getInstance()->Execute('TRUNCATE TABLE `'._DB_PREFIX_.'product_tag');
				Db::getInstance()->Execute('TRUNCATE TABLE `'._DB_PREFIX_.'image');
				Db::getInstance()->Execute('TRUNCATE TABLE `'._DB_PREFIX_.'image_lang');
				foreach (scandir(_PS_PROD_IMG_DIR_) AS $d)
					if (preg_match('/^[0-9]+\-[0-9]+\-(.*)\.jpg$/', $d) OR preg_match('/^([[:lower:]]{2})\-default\-(.*)\.jpg$/', $d))
						unlink(_PS_PROD_IMG_DIR_.$d);

}

//========================================Загрузка изображений========================================
function copyImg($id_entity, $id_image = NULL, $tmpfile)
{
global $log;
$log->LogInfo('Копирование картинки: '.$tmpfile);		
		$path = _PS_PROD_IMG_DIR_.intval($id_entity).'-'.intval($id_image);

		imageResize($tmpfile, $path.'.jpg');
		$imagesTypes = ImageType::getImagesTypes('product');
		foreach ($imagesTypes AS $k => $imageType)
			imageResize($tmpfile, $path.'-'.stripslashes($imageType['name']).'.jpg', $imageType['width'], $imageType['height']);
		unlink ($tmpfile);
		return true;
}

//========================================Добавление обновление изображений========================================
function addupdImg($product,$id_product)
{
global $notfull;
//Если нет атрибута или нет картинки выходим
	if (empty ($product->Картинка)||(!file_exists(_PS_PROD_PIC_DIR_ .$product->Картинка))) return false;
//Получаем ид картинки если есть
	if ($notfull) $id_image = Db::getInstance()->getValue("SELECT `id_image` FROM `"._DB_PREFIX_."image` WHERE  `cover`=1 AND `id_product`=".$id_product);

	if (!empty ($id_image)){
		//Обновляем
		Db::getInstance()->Execute("
			UPDATE `"._DB_PREFIX_."image_lang`
			SET `legend`='".$product->Наименование."'
			WHERE `id_lang`=3 AND `id_product`= ".$id_product
			);
	} else {
		//Добавляем
		Db::getInstance()->Execute("
			INSERT INTO `"._DB_PREFIX_."image` (`id_product`,`cover`)
			VALUES (".$id_product.", 1)
			");
		$id_image=Db::getInstance()->Insert_ID();
		Db::getInstance()->Execute("
			INSERT INTO `"._DB_PREFIX_."image_lang` (`id_image`,`id_lang`, `legend`)
			VALUES (".$id_image.", 3, '".$product->Наименование."')
			");
	}
	copyImg($id_product, $id_image, _PS_PROD_PIC_DIR_ .$product->Картинка);
	return $id_image;
}

//========================================Добавление или обновление категории========================================
function addupdcat($category,$parent,$level){
global $catar, $notfull;
	if ($notfull) $id_category = Db::getInstance()->getValue("SELECT `id_category` FROM `"._DB_PREFIX_."category` WHERE `xml`='".$category->Ид."'");
	if (!empty ($id_category)){
		//Обновляем
		Db::getInstance()->Execute("
			UPDATE `"._DB_PREFIX_."category_lang`
			SET `name`='".$category->Наименование."'
			WHERE `id_lang`=3 AND `id_category`= ".$id_category
			);
	} else {
		//Добавляем
		Db::getInstance()->Execute("
			INSERT INTO `"._DB_PREFIX_."category` (`xml`,`id_parent`,`level_depth`,`date_add`,`date_upd`,`active`)
			VALUES ('".$category->Ид."', ".$parent.", ".$level." , NOW(), NOW(), 1)
			");
		$id_category=Db::getInstance()->Insert_ID();
		Db::getInstance()->Execute("
			INSERT INTO `"._DB_PREFIX_."category_lang` (`id_category`,`id_lang`, `name`,`link_rewrite`)
			VALUES (".$id_category.", 3, '".$category->Наименование."', '".Tools::link_rewrite($category->Наименование)."')
			");
	};
	$catar[(string)$category->Ид]=$id_category;
	return $id_category;
}

//========================================Рекурсивная обработка категорий========================================
function reccat($category,$parent,$level){
	$parent=addupdcat($category,$parent,$level);
	if (!empty($category->Группы->Группа)){
		foreach($category->Группы->Группа as $cat) {
			reccat($cat,$parent,$level+1);
		};
	};
}



//========================================Добавление или обновление продукта========================================
function addupdprod($product){
global $catar, $notfull;
	if ((string)$product->Группы->Ид=='') {$catid=1;}else{$catid=$catar[(string)$product->Группы->Ид];};
	if ($notfull) $id_product = Db::getInstance()->getValue("SELECT `id_product` FROM `"._DB_PREFIX_."product` WHERE `xml`='".$product->Ид."'");
	if (!empty ($id_product)){
		//Обновляем
		Db::getInstance()->Execute("
			UPDATE `"._DB_PREFIX_."product`
			SET `reference`='".$product->Артикул."', `date_upd`=NOW()
			WHERE `id_product`= ".$id_product
			);
		Db::getInstance()->Execute("
			UPDATE `"._DB_PREFIX_."product_lang`
			SET `name`='".$product->Наименование."', `description_short`='".$product->ПолноеНаименование."'
			WHERE `id_lang`=3 AND `id_product`= ".$id_product
			);
	} else {
		//Добавляем
		Db::getInstance()->Execute("
			INSERT INTO `"._DB_PREFIX_."product` (`xml`,`reference`,`id_category_default`,`date_add`,`date_upd`,`active`)
			VALUES ('".$product->Ид."', '".$product->Артикул."' , ".$catid.", NOW(), NOW(), 1)
			");
		$id_product=Db::getInstance()->Insert_ID();
		
		Db::getInstance()->Execute("
			INSERT INTO `"._DB_PREFIX_."product_lang` (`id_product`,`id_lang`, `name`,`description_short`,`link_rewrite`)
			VALUES (".$id_product.", 3, '".$product->Наименование."', '".$product->ПолноеНаименование."', '".Tools::link_rewrite($product->Наименование)."')
			");
	}
	addupdImg($product,$id_product);
	return $id_product;
}


//========================================Извлечение цены========================================
function getprice($prices){
	foreach ($prices as $price)
	{
		if ($price->ИдТипаЦены=_PRICE_ID_) return str_replace(' ','',$price->ЦенаЗаЕдиницу);
	}
}

//========================================Обновление цен========================================
function upd_pricekol($xml){
	
	$price_tovar=$xml->ПакетПредложений->Предложения->Предложение;

	foreach ($price_tovar as $price_tovar_data)
	{
		Db::getInstance()->Execute("
			UPDATE IGNORE `"._DB_PREFIX_."product`
			SET `price`=".getprice($price_tovar_data->Цены->Цена).", `quantity`=".$price_tovar_data->Количество.", `date_upd`=NOW()
			WHERE `xml`= '".$price_tovar_data->Ид."'"
			);

	}
}

//========================================Выгрузка заказов========================================

function createzakaz(){

//Список заказов
	$list = Db::getInstance()->ExecuteS('
		SELECT  od.`id_order`, od.`date_add`, od.`total_paid`, ad.`firstname`, ad.`lastname`, ad.`address1`, ad.`phone`, ad.`city`
		FROM `'._DB_PREFIX_.'orders` od, `'._DB_PREFIX_.'address` ad, `'._DB_PREFIX_.'order_history` oh
		WHERE od.`id_address_delivery`=ad.`id_address` AND od.`id_order`=oh.`id_order` AND oh.`id_order_state`=3
	');

	if (!empty ($list))
	{
		$timechange	=	time();

		$no_spaces =  '<?xml version="1.0" encoding="UTF-8"?><КоммерческаяИнформация ВерсияСхемы="2.04" ДатаФормирования="' . date( 'Y-m-d', $timechange) . 'T' . date( 'H:m:s',$timechange) .  '"></КоммерческаяИнформация>';
		
		$xml = new SimpleXMLElement($no_spaces );

		foreach($list as $zakazy) {
			$doc	=	$xml->addChild("Документ");
			list($dt, $tm) = explode(" ", $zakazy['date_add']);
			$doc->addChild("Ид", 			$zakazy['id_order'] );
			$doc->addChild("Номер",	 		$zakazy['id_order'] );
			$doc->addChild("Дата", 			$dt);
			$doc->addChild("ХозОперация", 		"Заказ товара");
			$doc->addChild("Роль", 			"Продавец");
			$doc->addChild("Валюта", 		"руб");
			$doc->addChild("Курс", 			"1");
			$doc->addChild("Сумма", 		$zakazy['total_paid']);
			$doc->addChild("Время", 		$tm);



			// Контрагенты
				$FIO	=	$zakazy['lastname'] . " " . 	$zakazy['firstname'];

				$k1 = $doc->addChild('Контрагенты');
//Продавец
				$k2_1 = $k1->addChild('Контрагент');
//				$k2_2 = $k2_1->addChild("Ид"		,	"bd72d900-55bc-11d9-848a-00112f43529a");				
				$k2_2 = $k2_1->addChild("Наименование"		,	"Торговый дом &quot;Комплексный&quot;");
				$k2_2 = $k2_1->addChild("Роль"				,	"Продавец");

//Покупатель
				$k1_1 = $k1->addChild('Контрагент');
				$k1_2 = $k1_1->addChild("Наименование"		,	$FIO);
				$k1_2 = $k1_1->addChild("Роль"				,	"Покупатель");
				$k1_2 = $k1_1->addChild("ПолноеНаименование",	$FIO);
				$k1_2 = $k1_1->addChild("Имя"				,	$zakazy['firstname']);
				$k1_2 = $k1_1->addChild("Фамилия"			,	$zakazy['lastname']);

			/*$k1_3 = $k1_1->addChild("АдресРегистрации");
			$k1_4 = $k1_3->addChild("Представление");
			$k1_4 = $k1_3->addChild("АдресноеПоле");
			<Представление>87698</Представление>
			- <АдресноеПоле>
			<Тип>Почтовый индекс</Тип>
			<Значение>6546</Значение>
			</АдресноеПоле>
			- <АдресноеПоле>
			<Тип>Улица</Тип>
			<Значение>87698</Значение>
			</АдресноеПоле>
			</АдресРегистрации>
			*/





			$list_z = Db::getInstance()->ExecuteS('
				SELECT  p.`xml`, o.`product_name`, o.`product_quantity`, o.`product_price`, o.`product_quantity`*o.`product_price` as summ
				FROM `'._DB_PREFIX_.'order_detail` o, `'._DB_PREFIX_.'product` p
				WHERE o.`id_order`='.$zakazy['id_order'].' AND o.`product_id`=p.`id_product`
			');
			//Товары
			$t1 = $doc->addChild('Товары');
			foreach($list_z as $razbor_zakaza_t) {

				
				$t1_1 = $t1->addChild('Товар');
				$t1_2 = $t1_1->addChild("Ид",					$razbor_zakaza_t['xml']);
				$t1_2 = $t1_1->addChild("Наименование",			$razbor_zakaza_t['product_name']);
				$t1_2 = $t1_1->addChild("БазоваяЕдиница", "шт");
				$t1_2 -> addAttribute('Код', '796');
				$t1_2 -> addAttribute('НаименованиеПолное', 'Штука');
				$t1_2 -> addAttribute('МеждународноеСокращение', 'PCE');
				$t1_2 = $t1_1->addChild("ЦенаЗаЕдиницу",		$razbor_zakaza_t['product_price']);
				$t1_2 = $t1_1->addChild("Количество",			$razbor_zakaza_t['product_quantity']);
				$t1_2 = $t1_1->addChild("Сумма",				$razbor_zakaza_t['summ']);
				$t1_2 = $t1_1->addChild("ЗначенияРеквизитов");
				$t1_3 = $t1_2->addChild("ЗначениеРеквизита");
				$t1_4 = $t1_3->addChild("Наименование","ВидНоменклатуры");
				$t1_4 = $t1_3->addChild("Значение","Товар");

				$t1_2 = $t1_1->addChild("ЗначенияРеквизитов");
				$t1_3 = $t1_2->addChild("ЗначениеРеквизита");
				$t1_4 = $t1_3->addChild("Наименование","ТипНоменклатуры");
				$t1_4 = $t1_3->addChild("Значение","Товар");


			}

		}

		header("Content-type: text/xml; charset=utf-8");
		print $xml->asXML();

	} else {print "error\n";}

}


//========================================Товары========================================

if (Tools::getValue('type')== 'catalog'){

	#?type=catalog&mode=export
	// экспорт файлов
	if (Tools::getValue('mode') == 'export') {
		print 'success\n';
	}

	#?type=catalog&mode=init
	if (Tools::getValue('mode') == 'init') {
		print "zip=" . FIX_ZIP . "\n"  .	FIX_ZIPSIZE ;
	}
	
	# Авторизация выгрузки товаров
	# CATALOG
	//?type=catalog&mode=checkauth
	if (Tools::getValue('mode')== 'checkauth') {
		$log->LogInfo($_SERVER["PHP_AUTH_USER"]);
		$log->LogInfo($_SERVER["PHP_AUTH_PW"]);
		print "success\n";
	}
	
	// Передача файлов
	//?type=catalog&mode=file&filename=import.xml
	if (Tools::getValue('mode') == 'file' && Tools::getValue('filename'))
	{
		print loadfile() . "\n";
	}

	// проверка импорт файлов
	//?type=catalog&mode=import&filename=import.xml
	if (Tools::getValue('mode') == 'import') {
		$cnt	=	0;
	
		//switch(Tools::getValue('filename')){
		//case 'offers.xml':{
				//if (file_exists( _PS_PROD_PIC_DIR_ .'offers.xml'))
				//{

					//$log->addEntry(array('comment' => 'Анализ xml ' . _PS_PROD_PIC_DIR_ . 'import.xml'));

					$xml	=	simplexml_load_file(_PS_PROD_PIC_DIR_ . 'import.xml');

					$notfull	=	$xml->Каталог->attributes()->СодержитТолькоИзменения=="true";

					//Очистка базы
					if (!$notfull) ClearBase();

					//Загрузка категорий
					foreach($xml->Классификатор->Группы->Группа as $cat) {
						reccat($cat,1,1);
					};

					//Добавляем в категории-группы
					Db::getInstance()->Execute("
						INSERT IGNORE INTO `"._DB_PREFIX_."category_group`(`id_category`,`id_group`) SELECT id_category, 1 FROM `"._DB_PREFIX_."category`
						");

					//Загрузка продуктов
					foreach($xml->Каталог->Товары->Товар as $product) {
						addupdprod($product);
					};
					//Добавляем в категории-продукты
					Db::getInstance()->Execute("
						INSERT IGNORE INTO `"._DB_PREFIX_."category_product`(`id_product`,`id_category`) SELECT id_product,id_category_default FROM `"._DB_PREFIX_."product`
						");

					//print "success\n";

				//}

		//case 'offers.xml':{
				//if (file_exists( _PS_PROD_PIC_DIR_ .'offers.xml'))
				//{

					//$log->addEntry(array('comment' => 'Анализ xml ' . _PS_PROD_PIC_DIR_ . 'offers.xml'));
					$xml			=	simplexml_load_file(_PS_PROD_PIC_DIR_ .  'offers.xml');
					//Обновление цен
					upd_pricekol($xml);
					print "success\n";
				//}
		//}
	}

}

//========================================Продажи========================================

if (Tools::getValue('type')== 'sale'){

	# Авторизация загрузки заказов
	# SALE
	//connect.php?type=sale&mode=checkauth
	if (Tools::getValue('mode') == 'checkauth') {
		print "success\n";
	
	}
	
	//?type=sale&mode=query
	// Выгрузка заказов с типом P
	if (Tools::getValue('mode') == 'query') {
		createzakaz();
	}
	
	# отдаем файлы
	#?type=sale&mode=init
	if (Tools::getValue('mode') == 'init') {
		//print nl2br("zip=" . FIX_ZIP . "\n"  .	FIX_ZIPSIZE);
		print "zip=" . "no" . "\n"  .	FIX_ZIPSIZE;
	}

	//?type=sale&mode=success
	if (Tools::getValue('mode')== 'success') {
		print 'success\n';
	
	}
	
	
	
	// Передача файлов из 1С о принятых и измененных обменах
	// требуется разобраться, что отсылает 1
	//?type=sale&mode=file&filename=import.xml
	if (Tools::getValue('mode') == 'file' && Tools::getValue('filename'))
	{
		//$log->addEntry(array('comment' => 'получаем файл ' . getValue('filename')));
		$otvet	=	loadfile();
		if ($otvet == 'success')
		{
			//$log->addEntry(array('comment' => 'парсим файл ' . Tools::getValue(['filename']));
			$xml	=	simplexml_load_file( _PS_PROD_PIC_DIR_ . Tools::getValue('filename'));
			$doc = array();
			foreach ($xml->Документ as $docs)
			{
				$num	=	(int)$docs->Номер;
				/*$doc[$num]['Дата'] 			=	(string)$docs->Дата;
				$doc[$num]['Валюта'] 		=	(string)$docs->Валюта;
				$doc[$num]['Ид'] 			=	(string)$docs->Ид;
				$doc[$num]['Комментарий'] 	=	(string)$docs->Комментарий;
				$doc[$num]['Курс'] 			=	(int)$docs->Курс;
				$doc[$num]['Роль'] 			=	(string)$docs->Роль;
				$doc[$num]['ХозОперация'] 	=	(string)$docs->ХозОперация;
				$doc[$num]['Сумма'] 		=	(int)$docs->Сумма;
	
				foreach ($docs->ЗначенияРеквизитов->ЗначениеРеквизита as $rec) {
					$doc[$num]["$rec->Наименование"] = (string)$rec->Значение;
				}
				
				foreach ($docs->ЗначенияРеквизитов->ЗначениеРеквизита as $rec) {
					$doc[$num]["$rec->Наименование"] = (string)$rec->Значение;
				}*/
				
				#
				# Изменяем статус заказа в VirtueMart на статус полученный из 1С

				//$log->addEntry(array('comment' => 'изменяем в базе статус заказа ' . $num . " " . $doc[$num]["ПометкаУдаления"] ."," . $doc[$num]["Проведен"]));
				if ($doc[$num]["ПометкаУдаления"] == 'true') {
					Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'order_history` (`id_employee` ,`id_order` ,`id_order_state` ,`date_add`) VALUES (0 , '.$num.', 6, NOW())');
				}
				if ($doc[$num]["Проведен"] == 'true') {
					Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'order_history` (`id_employee` ,`id_order` ,`id_order_state` ,`date_add`) VALUES (0 , '.$num.', 4, NOW())');
				}
				#стираем файл ответа 1С
				if (file_exists( _PS_PROD_PIC_DIR_ .'offers.xml'))
				{
					unlink(_PS_PROD_PIC_DIR_ . Tools::getValue('filename'));
				}
			}
			print "success\n";
		}

		else
		{
			print "error " . $otvet;
		}
	}

}



// Чистим директории в папке загрузки xml
//if(is_dir('uploads/')) {rmdir_recurse('uploads/');} else {mkdir('uploads',0777);}


?>
	